
// app global variables
var sliderResetTimeout,tickTimer,slider;
var tickRunning = false;


// colors
var colors = {
	label: 		{ on: '#B0001B;' , off: '#b3babf;', past: '#6b6f73'},
	triGreen:	{ on: '#909756;' , off: '#ecece0;' },
	triYellow:	{ on: '#FFDD5F;' , off: '#faf8ee;' },
	triRed:		{ on: '#B0001B;' , off: '#e5e1e1;' }
	}

var tG = 'triGreen'; var tY = 'triYellow'; var tR = 'triRed';
var tri = {
	1: tG, 4: tG, 7: tG, 10: tG, 13: tG,
	2: tY, 5: tY, 8: tY, 11: tY, 14: tY,
	3: tR, 6: tR, 9: tR, 12: tR, 15: tR
	}

// css functions
function setTransform($obj, value){
	jQuery($obj).css({		  transform: value});
	jQuery($obj).css({		 oTransform: value});
	jQuery($obj).css({		msTransform: value});
	jQuery($obj).css({	   mozTransform: value});
	jQuery($obj).css({	webkitTransform: value});
	}


// calculate impulse
function calcImpulse(t){
	var r = {};
	
	r.now = Number(t)%(86400 / 50);			//__(r.now);
	r.deg = (360 / (86400 / 50)) * r.now;	//__(r.deg);
	r.imp = (15 / (86400 / 50)) * r.now;	//__(r.imp);
	
	return r;
	}


// calculate takte
function calcTakte(t){
	var r = {};
	
	r.now = Number(t) / (86400 / 50);		//__(r.now);
	r.deg = (360 / 50) * Math.floor(r.now);	//__(r.deg);
	
	return r;
	}


// show pacohoro time 
function phShowTime(t){

	if(typeof(t) != 'number'){
		var now = (new Date()).getTime()/1000;
		var inow = ((new Date()).getTime()/1000)-115.2;
		var nowSec = Number(now-Number(mktime( 0, 0, 0, date('m', now), date('d', now), date('Y', now) )));
		var inowSec = Number(inow-Number(mktime( 0, 0, 0, date('m', inow), date('d', inow), date('Y', inow) )));
		} else {
		var nowSec = t;
		var inowSec = (t <= 115.2) ? 86400+(t-115.2) : t-115.2;
		}
		
	var takte = calcTakte(nowSec);
	var itakte = calcTakte(inowSec);
	var impulse = calcImpulse(nowSec);
	var iimpulse = calcImpulse(inowSec);
		
	// digital display
	jQuery('#digiDisplay').val(Math.floor(takte.now)+':'+Math.floor(impulse.imp));

	// takte labels
	var past_sel = off_sel = '';
	for(i=1;i<Math.floor(itakte.now);i++) { past_sel += '#l'+i+' text,'; } past_sel = past_sel.substr(0, past_sel.length-1);
	for(i=Math.floor(itakte.now)+1;i<=50;i++) { off_sel += '#l'+i+' text,'; } off_sel = off_sel.substr(0, off_sel.length-1);
	jQuery(off_sel).attr('style','fill:'+colors.label.off);
	jQuery(past_sel).attr('style','fill:'+colors.label.past);
	
	jQuery('#l'+Math.floor(itakte.now)+' text').attr('style','fill:'+colors.label.on);
	if(Math.floor(itakte.now) == 50) __('!!!ERROR!!! -> search for in core.js'); // jQuery('#l0 text').attr('style','fill:'+colors.label.on);

	// takte pointer
	setTransform(jQuery('#degTakteDiv'), 'rotate('+itakte.deg+'deg)');
			
	// impulse
	for(i=1;i<=15;i++){		
		jQuery('#triangle'+i).attr('style','fill:'+colors[tri[i]][(i <= (Math.floor(iimpulse.imp)+1)) ? 'on' : 'off']);
		}
	
	// keep the time going on
	if(tickRunning){
//		if(typeof(slider) == 'object') slider.update({from: (nowSec+115.2)});
		if(typeof(slider) == 'object') slider.update({from: (nowSec)});
		tickTimer = window.setTimeout(phShowTime, 1000);
		}
	}
	

// when the slider is dragged
function valueOutput(value) {
	tickRunning = false; 	window.clearTimeout(tickTimer); tickTimer = null;
	
	window.clearTimeout(sliderResetTimeout);
	sliderResetTimeout = window.setTimeout(function (){
		var now = (new Date()).getTime()/1000;
		var nowSec = Math.round(now-Number(mktime( 0, 0, 0, date('m', now), date('d', now), date('Y', now) )));
		var sli = Math.round(jQuery("#range").val());
		var diff = (sli > nowSec) ? sli-nowSec : nowSec-sli; 
				
		fsDest = nowSec+1;
		fsCur = sli;
		fsSteps = diff/100;
		
		fadeSlider();
		
		}, 3000);
	
	phShowTime(Math.floor(value));
	}


// automatic return to current time
var fsDest,fsCur,fsSteps,fsTimeout;
var fsOdd = true;

function fadeSlider(){
	fsCur = (fsCur < fsDest) ? fsCur+fsSteps : fsCur-fsSteps;

	var takte = calcTakte(fsCur);

	// takte labels
	jQuery('text.labels, text.labelsB').attr('style','fill:'+colors.label.off);
	jQuery('#l'+Math.floor(takte.now)+' text').attr('style','fill:'+colors.label.on);
	if(Math.floor(takte.now) == 50) __('!!!ERROR!!! -> search for in core.js'); // jQuery('#l0 text').attr('style','fill:'+colors.label.on);

	// takte pointer
	setTransform(jQuery('#degTakteDiv'), 'rotate('+takte.deg+'deg)');
	
	// slider position
	if(fsOdd){
		if(typeof(slider) == 'object') slider.update({from: fsCur});
		}
	fsOdd = (fsOdd) ? false : true;
	
	if(!(fsCur >= fsDest-fsSteps && fsCur <= fsDest+fsSteps)){
		
		fsTimeout = setTimeout(fadeSlider, 1);
		} else {

		tickRunning = true; phShowTime();
		}
	}
	
var bgfadeTime = 5000;
var bgcolors = Array('#76c3d6;','#d6ce8a;','#dcb7b7','#98c3d0','#a1a394');
var currentCindex = 0;

function fadeColors(){
	if(currentCindex < bgcolors.length){
		currentCindex++;
		} else {
		currentCindex = 0;
		}
	jQuery('body').animate( { backgroundColor: bgcolors[currentCindex] }, bgfadeTime, fadeColors);
	}
